function varargout = BaSiC_GUI( varargin )
%Folder path: E:\Apps\BaSiC_TL\BaSiC_TLv1.1
%modify the file  BaSiC_config.m through a GUI. 

%   Detailed explanation goes here

clear; close all; clc;

set(0,'units','pixels')
sspix = get(0,'screensize');
H = figure('Position',[sspix(3)*.05 sspix(4)*.05 (sspix(3)*.9) (sspix(4)*.85)],...
    'CloseRequestFcn',@GUI_Close);


%cd into BaSiC Folder and add dcttool box to path
cd('E:\Apps\BaSiC_TL\BaSiC_TLv1.1')
addpath('E:\Apps\BaSiC_TL\BaSiC_TLv1.1\dcttool')


global GuIformat GuIdata;

%% Declare Global variables

GuIformat.color.c = [255/255 190/255 190/255];
GuIformat.color.o = [102/255 1 1];
GuIformat.color.i = [102/255 1 12/255];

% get todays date
% first yy mm dd
Year=num2str(year(date));
Day=num2str(day(date));
if(strlength(Day)==1)
    Day=strcat('0',Day);
end
MONTH=num2str(month(date));
if(strlength(MONTH)==1)
    MONTH=strcat('0',MONTH);
end
str =strcat(Year(3:end),MONTH,  Day);

%default paramters
GuIdata.Runit=logical(0);%to surpress closing function upon running AW171201
GuIdata.DATE=str;
GuIdata.TTTDIR = 'T:\TimelapseData\';
GuIdata.movieID= 'default';
GuIdata.MI_Suffix = sprintf('%s%s','BaSiC_',GuIdata.DATE);
GuIdata.temporalRangeII=[];
GuIdata.existSegmentation=logical(0); %AW171201
GuIdata.positionVectorI = 0;
GuIdata.lambdaFlatfield_allposition = 2.0;
GuIdata.runStepI = logical(0);
GuIdata.runAllPositionsI = logical(0);
GuIdata.runStepII = logical(0);
GuIdata.runAllPositionsII = logical(0);
GuIdata.useFlatfield_allposition = logical(1);
GuIdata.positionVectorII = 0;
GuIdata.lambdaFlatfield = [];
GuIdata.FluorWL_group = {'w05.png'};
GuIdata.lambdaDarkfield = [];
GuIdata.useSegmentation = logical(0);
GuIdata.runStepIII=logical(0);
GuIdata.runAllPositionsIII = logical(0);
GuIdata.positionVectorIII = 0;
GuIdata.temporalRangeIII = [];
GuIdata.runCorrection = logical(0);
GuIdata.adjustFlatfield= logical(0);
GuIdata.floatOutput = logical(1);

%% Control Panels
movie_information;
StepI;
StepII;
StepIII;
StepV;
end

%% PANEL CONTROL
function movie_information

global GuIformat GuIdata;

Control = uipanel('Visible','on',...
    'Position',[0.25 0.75 .5 .2],... % left bottom edge of panel within parentthen width and height.
    'Title','Movie Information');

%select TTT Folder
    GuIformat.MI(1) = uicontrol(Control,...
    'Units','normalized',...
    'Style','edit',...
    'String',' ',...
    'ForegroundColor',[0.4,0.4,0.4],...
    'Position',[0.02 0.6 .25 .2],...
    'Callback',@MI_TTTDIR);
    function MI_TTTDIR(hObject,callbackdata) %This Callback stores edited text and sets color to black  
        GuIdata.TTTDIR=get(GuIformat.MI(1),'string'); 
        set(GuIformat.MI(1),'ForegroundColor','black');
    end

    GuIformat.MI(3) = uicontrol(Control,...
    'Units','normalized',...
    'Style','text',...
    'String','Choose your Movie:',...
    'Position',[.02 0.8 .3 .1],...
    'HandleVisibility','off');

    GuIformat.MI(2) = uicontrol(Control,...
    'Units','normalized',...
    'Style','pushbutton',...
    'String','Browse',...
    'Position',[0.27 0.6 .1 .2],...
    'HandleVisibility','off',...
    'BackgroundColor',GuIformat.color.c,...
    'Callback',@MI_Browse);
    function MI_Browse(hObject,callbackdata)  
        a=uigetdir(GuIdata.TTTDIR, 'Pick a Directory'); 
        if a ~= 0
            %extract and set TTTDIR 
            %AW a=strsplit(a,'\');
            a= mystrsplit(a,'\');
            depth=length(a);
            TTTDIR=strjoin(a(1:end-1),repmat('\',1,depth-1));
            GuIdata.TTTDIR=strcat(TTTDIR,'\');
            %extract and set movie ID
            GuIdata.movieID=a{end};
            set(GuIformat.MI(4),'string',GuIdata.movieID); 
            set(GuIformat.MI(4),'ForegroundColor','black');
        end
        set(GuIformat.MI(1),'string',GuIdata.TTTDIR);
        set(GuIformat.MI(1),'ForegroundColor','black');
        
    end


 %Specify Movie ID
    GuIformat.MI(4) = uicontrol(Control,...
    'Units','normalized',...
    'Style','edit',...
    'String','',...
    'ForegroundColor',[0.4,0.4,0.4],...
    'Position',[0.42 0.6 .25 .2],...
    'CallBack',@MI_ID);
    function MI_ID(hObject,callbackdata) %This Callback stores edited text and sets color to black  
        GuIdata.movieID=get(GuIformat.MI(4),'string'); 
        set(GuIformat.MI(4),'ForegroundColor','black');
    end


   GuIformat.MI(5) = uicontrol(Control,...
    'Units','normalized',...
    'Style','text',...
    'String','Choosen Movie ID',...
    'Position',[.42 0.8 .2 .1],...
    'HandleVisibility','off');
 
 %Specify Wavelength
  GuIformat.MI(6) = uicontrol(Control,...
    'Units','normalized',...
    'Style','edit',...
    'String','e.g. w01.png, w02.png, w03.png' ,...
    'ForegroundColor',[0.4,0.4,0.4],...
    'Position',[0.72 0.6 .25 .2],...
    'CallBack',@MI_WL);
    function MI_WL(hObject,callbackdata) %This Callback stores edited text and sets color to black  
        %AW str = strsplit(get(GuIformat.MI(6),'string'),', ');
        str = mystrsplit(get(GuIformat.MI(6),'string'),', ');
        %Check if user appended .png already, if not do it. 
        pngcheck= ~contains(str, '.png');
        if sum(pngcheck) ~= 0
            str(pngcheck) = strcat(str(pngcheck),'.png');
        end      
        GuIdata.FluorWL_group = str;
        set(GuIformat.MI(6),'ForegroundColor','black');
    end


GuIformat.MI(7) = uicontrol(Control,...
    'Units','normalized',...
    'Style','text',...
    'String','Wavelength to process?',...
    'Position',[.72 0.8 .3 .1],...
    'HandleVisibility','off');

  
GuIformat.MI(8) = uicontrol(Control,...
    'Units','normalized',...
    'Style','text',...
    'String','BaSiC Suffix',...
    'Position',[.2 0.3 .25 .2],...
    'HandleVisibility','off');

GuIformat.MI(9) = uicontrol(Control,...
    'Units','normalized',...
    'Style','edit',...
    'String',GuIdata.DATE ,...
    'ForegroundColor',[0.4,0.4,0.4],...
    'Position',[.2 0.2 .25 .2],...
    'CallBack',@MI_Suffix);
    function MI_Suffix(hObject,callbackdata) %This Callback stores edited text and sets color to black  
        GuIdata.MI_Suffix=sprintf('%s%s','BaSiC_',get(GuIformat.MI(9),'string')); 
        set(GuIformat.MI(9),'ForegroundColor','black');
    end


GuIformat.MI(10) = uicontrol(Control,...
    'Units','normalized',...
    'Style','checkbox',...
    'String','Click Box to feel like Christmas',...
    'Position',[.6 0.15 .3 .4],...
    'Value', 0,...
    'Callback', @MI_Segment);
   function MI_Segment(hObject,callbackdata)  
   %AW171201     GuIdata.existSegmentation=get(GuIformat.MI(10),'Value'); 
   end


end

function StepI

global GuIformat GuIdata;

Control = uipanel('Visible','on',...
    'Position',[0 0.45 .30 .25],...
    'Title','Step I: Generation of flatfield_ap (a base flatfield for all positions)');

%Step1 is about generating flatfield_ap in outputDirectory; if exist, please set runStepI to false
 GuIformat.StepI(1) = uicontrol(Control,...
    'Units','normalized',...
    'Style','checkbox',...
    'String','Generate new flatfield?',...
    'Position',[.0 0.7 .3 .4],...
    'Value', 0,...
    'Callback', @runStepI);
   

            %runAllPositions?
            GuIformat.StepI(2) = uicontrol(Control,...
                'Units','normalized',...
                'Style','checkbox',...
                'String','Use all positions in movie folder?',...
                'Position',[.4 0.7 .4 .4],...
                'Value', 0,...
                'Callback', @runAllPositions1);
                

            %create Position Vector
            GuIformat.StepI(3) = uicontrol(Control,...
                'Units','normalized',...
                'Style','edit',...
                'String','e.g. 7, 10 or 7, 1:5',...
                'ForegroundColor',[0.4,0.4,0.4],...
                'Position',[0.0 0.2 .4 .2],...
                'Callback',@positionVectorI);


            GuIformat.StepI(4) = uicontrol(Control,...
                'Units','normalized',...
                'Style','text',...
                'String','Specify Positions',...
                'Position',[0 0.4 .4 .2],...
                'HandleVisibility','off');

            %Lambda Parameter
            GuIformat.StepI(5) = uicontrol(Control,...
                'Units','normalized',...
                'Style','edit',...
                'String','between 0 and 5.0, default 2.0',...
                'ForegroundColor',[0.4,0.4,0.4],...
                'Position',[0.6 0.2 .4 .2],...
                'Callback',@lambda1);

           GuIformat.StepI(6) = uicontrol(Control,...
                'Units','normalized',...
                'Style','checkbox',...
                'String','Specify Lambda for Flatfield',...
                'Position',[0.6 0.4 .4 .2],...
                'HandleVisibility','off',...
                'Callback',@lambdacheck);

            GuIformat.StepI(7) = uicontrol(Control,...
                'Units','normalized',...
                'Style','pushbutton',...
                'String','?',...
                'ForegroundColor','red',...
                'Position',[0.95 0.3 0.05 .1],...
                'Callback',@lambdahelp);
              
        
        
        %reinitiate panel if unticked to hide input from user
        if get( GuIformat.StepI(1), 'Value') ~= get( GuIformat.StepI(1), 'Max')
            set(GuIformat.StepI(2),'Enable','off');
            set(GuIformat.StepI(3),'Enable','off');
            set(GuIformat.StepI(4),'Enable','off');
            set(GuIformat.StepI(5),'Enable','off');
            set(GuIformat.StepI(6),'Enable','off');
            set(GuIformat.StepI(7),'Enable','off');
        end
        

         
    

%These functions will only be called if the user generates new flatfile
 function runStepI(hObject,callbackdata)
       
        %check if exist elsewise create flatfield_ap
        GuIdata.outputDirectory = sprintf('%s/%s/Analysis/%s/',GuIdata.TTTDIR,GuIdata.movieID,GuIdata.MI_Suffix);
        check=exist(fullfile(GuIdata.outputDirectory, 'flatfield_ap'));
        
        if check == 0 %flatfile not there
            GuIdata.runStepI=logical(get( GuIformat.StepI(1), 'Value'));
             %if get( GuIformat.StepI(1), 'Value') == get( GuIformat.StepI(1), 'Max')
             %   msgbox('Will run SLIC to generate new flatfield_ap. Specify remaining parameters!')
             %end
        else %flatfile is there
            GuIdata.runStepI=logical(get( GuIformat.StepI(1), 'Value'));
            %if get(GuIformat.StepI(1), 'Value') == get( GuIformat.StepI(1), 'Max')
             %   warndlg('Found flatfield_ap: Running SIC again is not recommended, but if you do specify remaining parameters')
            %end
        end
        
        %visualize rest of panel when flatfile has to be created
        if GuIdata.runStepI == get( GuIformat.StepI(1), 'Max')
            set(GuIformat.StepI(2),'Enable','on');
            set(GuIformat.StepI(3),'Enable','on');
            set(GuIformat.StepI(4),'Enable','on');
            set(GuIformat.StepI(5),'Enable','off');
            set(GuIformat.StepI(6),'Enable','on');
            set(GuIformat.StepI(7),'Enable','on');
            
        end
        
           if GuIdata.runStepI == get( GuIformat.StepI(1), 'Min')
            set(GuIformat.StepI(2),'Enable','off');
            set(GuIformat.StepI(3),'Enable','off');
            set(GuIformat.StepI(4),'Enable','off');
            set(GuIformat.StepI(5),'Enable','off');
            set(GuIformat.StepI(6),'Enable','off');
            set(GuIformat.StepI(7),'Enable','off');
           end 
        
 end

    function runAllPositions1(hObject,callbackdata)
        GuIdata.runAllPositionsI=logical(get(GuIformat.StepI(2), 'Value'));
        if get(GuIformat.StepI(2), 'Value') == get(GuIformat.StepI(2), 'Min')
            %warndlg('Create Position Vector!')
            set(GuIformat.StepI(3),'Enable','on');
            set(GuIformat.StepI(4),'Enable','on');
        end
        
        %hide positional input from user if all positions are being used
        if GuIdata.runAllPositionsI == 1
            set(GuIformat.StepI(3),'Enable','off');
            set(GuIformat.StepI(4),'Enable','off');
        end
        
    end

    function lambdahelp(hObject,callbackdata)  
       %pop up with explanation when ? is pressed
        msgbox('Check the ouptut flatfield_allposition. If not smooth, please increase lambdaFlatfield_all if oversmooth decrease it')
    end

    function lambda1(hObject,callbackdata) %This Callback stores edited text and sets color to black  
        %Get input and convert to numeric
        Input=str2num(get(GuIformat.StepI(5),'string'));%string into cell separated by comma
        GuIdata.lambdaFlatfield_allposition=Input;
        set(GuIformat.StepI(5),'ForegroundColor','black');
    end

    function positionVectorI(hObject,callbackdata) %This Callback stores edited text and sets color to black  
        %Get input and convert to numeric array
        Input=stringconvert(get(GuIformat.StepI(3),'string'));%string into cell separated by comma
        GuIdata.positionVectorI=Input;
        GuIdata.positionVectorII=Input;
        GuIdata.positionVectorIII=Input;
        set(GuIformat.StepI(3),'ForegroundColor','black');
        set(GuIformat.StepII(3),'string','same as Step I');
        set(GuIformat.StepII(3),'ForegroundColor','black');
        set(GuIformat.StepIII(3),'string','same as Step I');
        set(GuIformat.StepIII(3),'ForegroundColor','black');

    end

    function lambdacheck(hObject,callbackdata) %This will enable the edit field linked to specifying lambda
        lambdacheck=get(GuIformat.StepI(6), 'Value');
        switch lambdacheck
            case 1
                set(GuIformat.StepI(5), 'Enable', 'on');
                
            case 0 
                set(GuIformat.StepI(5), 'Enable', 'off');
                GuIdata.lambdaFlatfield_allposition = 2.0; %the default for lambda

        end
        
    end

end

    
function StepII 

global GuIformat GuIdata;

Control = uipanel('Visible','on',...
    'Position',[0.305 0.45 .39 .25],...
    'Title','Step II: Generation of position-wise flatfield and darkfield');

%generate new position-wise flatfield & darkfield?
 GuIformat.StepII(1) = uicontrol(Control,...
    'Units','normalized',...
    'Style','checkbox',...
    'String','generate new position-wise flat- & darkfield?',...
    'Position',[.0 0.7 .6 .4],...
    'Value', 0,...
    'Callback', @runStep2);

   
            
    %%%%%%%%%the following parameters%%%%%%%%%

    %run all positions?
    GuIformat.StepII(2)=uicontrol(Control,...
        'Units','normalized',...
        'Style','checkbox',...
        'String','Use all positions in movie folder?',...
        'Position',[.5 0.7 .6 .4],...
        'Value', 0,...
        'Callback',@runAllPositions2);
    
    
    %if not all positions are used specify the position vector

    
        GuIformat.StepII(4) = uicontrol(Control,...
            'Units','normalized',...
            'Style','text',...
            'String','Specify Positions (same as Step1)',...
            'Position',[0 0.6 .4 .2],...
            'HandleVisibility','off');
        
        GuIformat.StepII(3) = uicontrol(Control,...
            'Units','normalized',...
            'Style','edit',...
            'String','e.g. 7, 10 or 7, 1:5',...
            'ForegroundColor',[0.4,0.4,0.4],...
            'Position',[0.02 0.5 .4 .2],...
            'Callback',@positionVectorII);



       GuIformat.StepII(6) = uicontrol(Control,...
            'Units','normalized',...
            'Style','text',...
            'String','Time Range:[Min Max] or leave empty',...
            'Position',[0.5 0.6 .4 .2],...
            'HandleVisibility','off');
        
        
       GuIformat.StepII(5) = uicontrol(Control,...
            'Units','normalized',...
            'Style','edit',...
            'String','Min , Max',...
            'ForegroundColor',[0.4,0.4,0.4],...
            'Position',[0.5 0.5 .4 .2],...
            'Callback',@temporalRangeII);


     
       GuIformat.StepII(7) = uicontrol(Control,...
            'Units','normalized',...
            'Style','checkbox',...
            'String','Estimate Dark-/Flatfield per position? (Ignore Step I)',...
            'Position',[0 0.3 .4 .2],...
            'HandleVisibility','off',...
            'Value', 0,...
            'Callback', @useFlatfield_allposition);
       
        GuIformat.StepII(8) = uicontrol(Control,...
            'Units','normalized',...
            'Style','checkbox',...
            'String','Use Segmentation for Dark-/Flatfield computation',...
            'Position',[0.5 0.3 .5 .2],...
            'Callback', @useSegmentation);
        
        GuIformat.StepII(9) = uicontrol(Control,...
            'Units','normalized',...
            'Style','text',...
            'String','Lambda for Darkfield (ADVANCED)',...
            'Position',[0.0 0.1 .4 .2]);
        
        GuIformat.StepII(10) = uicontrol(Control,...
            'Units','normalized',...
            'Style','text',...
            'String','Lambda for Flatfield (ADVANCED)',...
            'Position',[0.5 0.1 .4 .2]);
        
        GuIformat.StepII(11) = uicontrol(Control,...
            'Units','normalized',...
            'Style','edit',...
            'String','e.g. 4, or leave empty',...
            'ForegroundColor',[0.4,0.4,0.4],...
            'Position',[0. 0.0 .4 .2],...
            'Callback', @lambdaFlatfield);
        
        GuIformat.StepII(12) = uicontrol(Control,...
            'Units','normalized',...
            'Style','edit',...
            'String','e.g. 4, or leave empty',...
            'ForegroundColor',[0.4,0.4,0.4],...
            'Position',[0.5 0.0 .4 .2],...
            'Callback', @lambdaDarkfield);
             
        
        %if no flatfield wanted, hide input from user
        if get(GuIformat.StepII(1), 'Value') == get( GuIformat.StepII(1), 'Min')
            set(GuIformat.StepII(2),'Enable','off');
            set(GuIformat.StepII(4),'Enable','off');
            set(GuIformat.StepII(3),'Enable','off');
            set(GuIformat.StepII(5),'Enable','off');
            set(GuIformat.StepII(6),'Enable','off');
            set(GuIformat.StepII(7),'Enable','off');
            set(GuIformat.StepII(8),'Enable','off');
            set(GuIformat.StepII(9),'Enable','off');
            set(GuIformat.StepII(10),'Enable','off');
            set(GuIformat.StepII(11),'Enable','off');
            set(GuIformat.StepII(12),'Enable','off');
        end
    
    %%%%%%%%%the Callback functions of this panel %%%%%%%%%
     function runStep2(hObject,callbackdata)

    %if yes, then specify following parameters
        GuIdata.runStepII=logical(get( GuIformat.StepII(1), 'Value'));
        if get( GuIformat.StepII(1), 'Value') == get( GuIformat.StepII(1), 'Max')
            %msgbox('Please specify the following parameters')
        end
        
        %make input visible for user
        if get( GuIformat.StepII(1), 'Value') == get( GuIformat.StepII(1), 'Max')
            set(GuIformat.StepII(2),'Enable','on');
            set(GuIformat.StepII(3),'Enable','on');
            set(GuIformat.StepII(4),'Enable','on');
            set(GuIformat.StepII(5),'Enable','on');
            set(GuIformat.StepII(6),'Enable','on');
            set(GuIformat.StepII(7),'Enable','on');
            set(GuIformat.StepII(8),'Enable','on');
            set(GuIformat.StepII(9),'Enable','on');
            set(GuIformat.StepII(10),'Enable','on');
            set(GuIformat.StepII(11),'Enable','on');
            set(GuIformat.StepII(12),'Enable','on');
        end
        if get( GuIformat.StepII(1), 'Value') == get( GuIformat.StepII(1), 'Min')
            set(GuIformat.StepII(2),'Enable','off');
            set(GuIformat.StepII(3),'Enable','off');
            set(GuIformat.StepII(4),'Enable','off');
            set(GuIformat.StepII(5),'Enable','off');
            set(GuIformat.StepII(6),'Enable','off');
            set(GuIformat.StepII(7),'Enable','off');
            set(GuIformat.StepII(8),'Enable','off');
            set(GuIformat.StepII(9),'Enable','off');
            set(GuIformat.StepII(10),'Enable','off');
            set(GuIformat.StepII(11),'Enable','off');
            set(GuIformat.StepII(12),'Enable','off');
        end
     end  

    function runAllPositions2(hObject,callbackdata)
            GuIdata.runAllPositionsII=logical(get(GuIformat.StepII(2), 'Value'));
            if get(GuIformat.StepII(2), 'Value') == get(GuIformat.StepII(2), 'Min')
                %warndlg('Create Position Vector!')
                set(GuIformat.StepII(3),'Enable','on');
                set(GuIformat.StepII(4),'Enable','on');
            end
            if get(GuIformat.StepII(2), 'Value') == get(GuIformat.StepII(2), 'Max')
                set(GuIformat.StepII(3),'Enable','off');
                set(GuIformat.StepII(4),'Enable','off');
            end
        end
    
        function temporalRangeII (hObject,callbackdata)
            string= get(GuIformat.StepII(5), 'String');
            %check if some value was specified and 
            %AW check=isnan(str2double(strsplit(string,', ')));
            if isempty(string)
                GuIdata.temporalRangeII = [];
            else 
                GuIdata.temporalRangeII=stringconvert(string);
            end
            
            set(GuIformat.StepII(5),'ForegroundColor','black')
        end
     

        function useFlatfield_allposition (hobject, callbackdata)
            %have to invert user input because user is aksed inverse question
            %to what BaSiC actually wants to know. 
            GuIdata.useFlatfield_allposition= ~logical(get(GuIformat.StepII(7), 'Value'));
        end

    
        function positionVectorII (hobject, callbackdata)
            string=get(GuIformat.StepII(3),'string');
            GuIdata.positionVectorII=stringconvert(string);
            set(GuIformat.StepII(3),'ForegroundColor','black');
        end

        function useSegmentation (hobject, callbackdata)
             GuIdata.useSegmentation= logical(get(GuIformat.StepII(8), 'Value'));
        end
        
        function lambdaDarkfield (hobject, callbackdata)
            string=get(GuIformat.StepII(12),'string');
            GuIdata.lambdaDarkfield= stringconvert(string);
            set(GuIformat.StepII(12),'ForegroundColor','black');
        end

        function lambdaFlatfield (hobject, callbackdata)
            string=get(GuIformat.StepII(11),'string');
            GuIdata.lambdaFlatfield= stringconvert(string);
            set(GuIformat.StepII(11),'ForegroundColor','black');
        end
    
end

function StepIII 

global GuIformat GuIdata;

Control = uipanel('Visible','on',...
    'Position',[0.7 0.45 .3 .25],...
    'Title','Step III: Generation of baseline fluorescence to correct background bleaching');
        
 %generate new basefluor?
 GuIformat.StepIII(1) = uicontrol(Control,...
    'Units','normalized',...
    'Style','checkbox',...
    'String','Generate new basefluor?',...
    'Position',[.0 0.7 .6 .4],...
    'Value', 0,...
    'Callback', @runStep3);

   
            
    %%%%%%%%%the following parameters%%%%%%%%%

    %run all positions?
    GuIformat.StepIII(2)=uicontrol(Control,...
        'Units','normalized',...
        'Style','checkbox',...
        'String','Use all positions in movie folder?',...
        'Position',[.6 0.7 .6 .4],...
        'Value', 0,...
        'Callback',@runAllPositions3);
    
    
    %if not all positions are used specify the position vector
        GuIformat.StepIII(4) = uicontrol(Control,...
            'Units','normalized',...
            'Style','text',...
            'String','Specify Positions (same as Step1)',...
            'Position',[0 0.6 .4 .2],...
            'HandleVisibility','off');
        
        GuIformat.StepIII(3) = uicontrol(Control,...
            'Units','normalized',...
            'Style','edit',...
            'String','e.g. 7, 10 or 7, 1:5',...
            'ForegroundColor',[0.4,0.4,0.4],...
            'Position',[0.02 0.5 .4 .2],...
            'Callback',@positionVectorIII);



       GuIformat.StepIII(9) = uicontrol(Control,...
            'Units','normalized',...
            'Style','text',...
            'String','Time Range:[Min Max] or leave empty',...
            'Position',[0.6 0.6 .4 .2],...
            'HandleVisibility','off');
        
        
       GuIformat.StepIII(5) = uicontrol(Control,...
            'Units','normalized',...
            'Style','edit',...
            'String','Min , Max',...
            'ForegroundColor',[0.4,0.4,0.4],...
            'Position',[0.6 0.5 .4 .2],...
            'Callback',@temporalRangeIII);

        
     GuIformat.StepIII(6) = uicontrol(Control,...
            'Units','normalized',...
            'Style','checkbox',...
            'String','Export Corrected Images',...
            'Position',[0.0 0.2 .4 .2],...
            'HandleVisibility','off',...
            'Callback', @runCorrection);
        
    GuIformat.StepIII(7) = uicontrol(Control,...
            'Units','normalized',...
            'Style','checkbox',...
            'String','Use ratioflat in correction',...
            'Position',[0.3 0.2 .4 .2],...
            'HandleVisibility','off',...
            'Callback', @adjustFlatfield);
        
               
    GuIformat.StepIII(8) = uicontrol(Control,...
            'Units','normalized',...
            'Style','checkbox',...
            'String',' 8 bit png conversion? (Tif default)',...
            'Position',[0.6 0.2 .4 .2],...
            'HandleVisibility','off',...
            'Callback', @floatOutput);
  
        
        %if no new basefluor wanted, hide input from user
        if get(GuIformat.StepIII(1), 'Value') == get( GuIformat.StepIII(1), 'Min')
            set(GuIformat.StepIII(2),'Enable','off');
            set(GuIformat.StepIII(4),'Enable','off');
            set(GuIformat.StepIII(3),'Enable','off');
            set(GuIformat.StepIII(5),'Enable','off');
            set(GuIformat.StepIII(6),'Enable','off');
            set(GuIformat.StepIII(7),'Enable','off');
            set(GuIformat.StepIII(8),'Enable','off');
            set(GuIformat.StepIII(9),'Enable','off');

        end 
        
        
        %%%%%%%%%%%%Callback Functions%%%%%%%%%%%%%%%%%%%%
        function runStep3(hObject,callbackdata)

        %if yes, then specify following parameters
        GuIdata.runStepIII=logical(get( GuIformat.StepIII(1), 'Value'));
        %if get( GuIformat.StepIII(1), 'Value') == get( GuIformat.StepIII(1), 'Max')
        %    msgbox('Will run SLIC to generate new flatfield_ap. Specify remaining parameters!')
        %end
        
        %make input visible for user
        if get(GuIformat.StepIII(1), 'Value') == get( GuIformat.StepIII(1), 'Max')
            set(GuIformat.StepIII(2),'Enable','on');
            set(GuIformat.StepIII(3),'Enable','on');
            set(GuIformat.StepIII(4),'Enable','on');
            set(GuIformat.StepIII(5),'Enable','on');
            set(GuIformat.StepIII(6),'Enable','on');
            if(get(GuIformat.StepIII(6), 'Value') == 0)
                set(GuIformat.StepIII(7),'Enable','off');
                set(GuIformat.StepIII(8),'Enable','off');
            else
                set(GuIformat.StepIII(7),'Enable','on');
                set(GuIformat.StepIII(8),'Enable','on');
            end
            set(GuIformat.StepIII(9),'Enable','on');
        end
        
        if get( GuIformat.StepIII(1), 'Value') == get( GuIformat.StepII(1), 'Min')
            set(GuIformat.StepIII(2),'Enable','off');
            set(GuIformat.StepIII(3),'Enable','off');
            set(GuIformat.StepIII(4),'Enable','off');
            set(GuIformat.StepIII(5),'Enable','off');
            set(GuIformat.StepIII(6),'Enable','off');
            set(GuIformat.StepIII(7),'Enable','off');
            set(GuIformat.StepIII(8),'Enable','off');
            set(GuIformat.StepIII(9),'Enable','off');
        end
      end  
 
    
      function runAllPositions3(hObject,callbackdata)
            GuIdata.runAllPositionsIII=logical(get(GuIformat.StepIII(2), 'Value'));
            if get(GuIformat.StepIII(2), 'Value') == get(GuIformat.StepIII(2), 'Min')
                %warndlg('Create Position Vector!')
                set(GuIformat.StepIII(3),'Enable','on');
                set(GuIformat.StepIII(4),'Enable','on');
            end
            if get(GuIformat.StepIII(2), 'Value') == get(GuIformat.StepIII(2), 'Max')
                set(GuIformat.StepIII(3),'Enable','off');
                set(GuIformat.StepIII(4),'Enable','off');
            end
      end
    
    
      
        function positionVectorIII (hobject, callbackdata)
            string=get(GuIformat.StepIII(3),'string');
            GuIdata.positionVectorIII=stringconvert(string);
            set(GuIformat.StepIII(3),'ForegroundColor','black');
        end
    
    
       function temporalRangeIII (hObject,callbackdata)
            string= get(GuIformat.StepIII(5), 'String');
            %check if some value was specified and 
            %AW check=isnan(str2double(strsplit(string,', ')));
            if isempty(string)
                GuIdata.temporalRangeIII = [];
            else 
                GuIdata.temporalRangeIII=stringconvert(string);
            end
            
            set(GuIformat.StepIII(5),'ForegroundColor','black')
        end


        function runCorrection (hobject, callbackdata)
            Correctioncheck=get( GuIformat.StepIII(6), 'Value');
            switch Correctioncheck
                case 1
                msgbox('When running BaSiC, you will generate hundreds of background corrected images in your position folders!')
                    set(GuIformat.StepIII(7),'Enable','on');
                    set(GuIformat.StepIII(8),'Enable','on');
                case 0
                    set(GuIformat.StepIII(7),'Enable','off');
                    set(GuIformat.StepIII(8),'Enable','off');
           end
           GuIdata.runCorrection = logical(get( GuIformat.StepIII(6), 'Value'));
        end
    
        function adjustFlatfield (hobject, callbackdata)
             GuIdata.adjustFlatfield= logical(get(GuIformat.StepIII(7), 'Value'));
        end
    
     
        function floatOutput (hobject, callbackdata)
            %needs to be inverted since user is asked inverse question
             GuIdata.floatOutput= ~(logical(get(GuIformat.StepIII(8), 'Value')));
        end
    
    
    
        
    
end


function StepV 

global GuIformat GuIdata;

Control = uipanel('Visible','on',...
    'Position',[0.3 0.3 .3 .1],...
    'Title','Step V: run BaSiC_main');

 GuIformat.StepV(1) = uicontrol(Control,...
            'Units','normalized',...
            'Style','Pushbutton',...
            'String','RUN BaSiC',...
            'ForegroundColor',[0.4,0.4,0.4],...
            'Position',[0.15 0.25 .7 .5],...
            'Callback',@Runit);
        
    function Runit(hobject, callbackdata)
        GuIdata.Runit=logical(1);%to surpress closing function upon running AW171201
        %Give FB when running
        saveit;
        %run it within same matlab instance
        BaSiC_main_AW([GuIdata.outputDirectory '/BaSiCconfig.mat']);
        
    end
end


%%Helper Functions
   function saveit
   global GuIformat GuIdata;

        %save parameters to outputDirectory '/BaSiCconfig.mat'];
         BaSiCconfig = matfile('BaSiCconfig.mat');
       
        % Movie Data
        inputDirectory = sprintf('%s/%s/',GuIdata.TTTDIR,GuIdata.movieID); % inputDiectory where the images are stored
        outputDirectory = sprintf('%s/%s/Analysis/',GuIdata.TTTDIR,GuIdata.movieID);
        outputDirectory = sprintf('%s%s/',outputDirectory,GuIdata.MI_Suffix);
        GuIdata.outputDirectory=outputDirectory;
 
        %check if GuIdata.MI_Suffix already taken by folder
        BaSiC_check=exist(outputDirectory)==7; % so we can throw warning later
        %check if segmentation exists
        listing=dir(sprintf('%s/%s/Analysis',GuIdata.TTTDIR,GuIdata.movieID));
        foldernum=size(listing,1);
        %check if contained folders are Segmentation folders
        %AW171201 Segmentationfolders=string();
        %AW171201for f=1:foldernum
        %AW171201    Suspect=getfield(listing,{f}, 'name');
        %AW171201    if contains(Suspect,'Segmentation')
        %AW171201        Segmentationfolders=[Segmentationfolders, Suspect];
        %AW171201    end
        %AW171201 end
        %AW171201 Segmentationfolders=Segmentationfolders(contains(Segmentationfolders,'Segmentation'));
        %AW171201 existSegmentation= ~isempty(Segmentationfolders); %does Segmentation exist?
            
       %create mafile to fill in 
        mkdir(outputDirectory)
        movieID=GuIdata.movieID;
        %AW171201 GuIdata.existSegmentation=existSegmentation;
        %AW171201 if(existSegmentation)
            %take newest Segmentation by default
        %AW171201    segmentationDirectory=sprintf('%s/%s/Analysis%s%s',GuIdata.TTTDIR,GuIdata.movieID,'/',Segmentationfolders(end));
        %AW171201 else
        %AW171201                segmentationDirectory='NOPE';
        %AW171201 end
        
        %AW171201 GuIdata.segmentationDirectory=segmentationDirectory;
        
        existSegmentation= GuIdata.existSegmentation;       %AW171201
        segmentationDirectory='NOPE';                       %AW171201
        GuIdata.segmentationDirectory=segmentationDirectory;%AW171201
        
        
        MATFILE=fullfile(outputDirectory,'BaSiCconfig.mat');
        BaSiCconfig=matfile(MATFILE, 'Writable',logical(1)); 
        BaSiCconfig.inputDirectory=inputDirectory;
        BaSiCconfig.outputDirectory=outputDirectory;
        BaSiCconfig.existSegmentation=existSegmentation;
        BaSiCconfig.segmentationDirectory=segmentationDirectory;
        BaSiCconfig.movieID=movieID;
        %Step1 Data
        runStepI = GuIdata.runStepI;
        runAllPositionsI = GuIdata.runAllPositionsI;
        positionVectorI = GuIdata.positionVectorI;
        lambdaFlatfield_allposition = GuIdata.lambdaFlatfield_allposition;
        FluorWL_group=GuIdata.FluorWL_group;
        BaSiCconfig.runStepI=runStepI;
        BaSiCconfig.runAllPositionsI=runAllPositionsI;
        BaSiCconfig.positionVectorI=positionVectorI;
        BaSiCconfig.lambdaFlatfield_allposition=lambdaFlatfield_allposition;
        BaSiCconfig.FluorWL_group=FluorWL_group;
        
        %Step2 Data
        runStepII=GuIdata.runStepII;
        runAllPositionsII =GuIdata.runAllPositionsII;
        temporalRangeII = GuIdata.temporalRangeII;
        useFlatfield_allposition = GuIdata.useFlatfield_allposition;
        positionVectorII = GuIdata.positionVectorII;
        lambdaFlatfield = GuIdata.lambdaFlatfield;
        lambdaDarkfield = GuIdata.lambdaDarkfield;
        useSegmentation = GuIdata.useSegmentation;
        BaSiCconfig.runStepII=runStepII;
        BaSiCconfig.temporalRangeII=temporalRangeII;
        BaSiCconfig.runAllPositionsII=runAllPositionsII;
        BaSiCconfig.positionVectorII=positionVectorII;
        BaSiCconfig.lambdaFlatfield=lambdaFlatfield;
        BaSiCconfig.lambdaDarkfield=lambdaDarkfield;
        BaSiCconfig.useSegmentation=useSegmentation;
        BaSiCconfig.useFlatfield_allposition=useFlatfield_allposition;
        %Step3 Data
        runStepIII= GuIdata.runStepIII;
        runAllPositionsIII = GuIdata.runAllPositionsIII;
        positionVectorIII = GuIdata.positionVectorIII;
        temporalRangeIII = GuIdata.temporalRangeIII;
        runCorrection = GuIdata.runCorrection;
        adjustFlatfield = GuIdata.adjustFlatfield;
        floatOutput = GuIdata.floatOutput;
        BaSiCconfig.runStepIII=runStepIII;
        BaSiCconfig.runAllPositionsIII=runAllPositionsIII;
        BaSiCconfig.positionVectorIII=positionVectorIII;
        BaSiCconfig.temporalRangeIII=temporalRangeIII;
        BaSiCconfig.runCorrection=runCorrection;
        BaSiCconfig.adjustFlatfield=adjustFlatfield;
        BaSiCconfig.floatOutput=floatOutput;
        
        %Give FB when done 
        %msgbox(sprintf('%s%s', 'BaSiC Configuration saved under ',outputDirectory));

    end
    
function GUI_Close(hObject,callbackdata)
% Close request function
% to display a question dialog box

global GuIformat GuIdata

    if (~GuIdata.Runit) %if Runit was cliked (stepV), then do not show this box
        selection = questdlg('Close The GUI and abort BaSiC configuration?',...
            'Close Request Function',...
            'Yes','No','Yes');
        switch selection,
            case 'Yes',
                delete(gcf)
            case 'No'
                return
        end
    end
    GuIdata.Runit=logical(0) %to reset after running AW171201

end

function [vector]=stringconvert(string)
%input will be '1,4, 8' or '1:2, 4, 6, 9:14' we want [1 2 4 6 9 10 11 12..]
    %AW a=strsplit(string,', '); %string into cell separated by comma
    a=mystrsplit(string,', ');
    numbers=[];
    for i = a
        i = vectorize(i); %cell 2 vector 
        numbers = [numbers,str2num(i)]; %string 2 num and append
    end
    vector=numbers;
end


function h = MessageBox(message,title,messageType,hideOk)
% Show message box
% Source: https://www.mathworks.com/matlabcentral/newsreader/view_thread/117288

if ~exist('messageType','var')
    messageType = 'help';
end

if ~exist('hideOk','var')
    hideOk = 1;
end

h = msgbox(message,title,messageType);
child = get(h,'Children');

if hideOk
    delete(child(1)); % Removes ok button
    drawnow;
end

end


